Subject: Re: [weirds] comments on draft-ietf-weirds-rdap-query-10

From: "Hollenbeck, Scott" <[email-masked]>
Date: Wed, 23 Jul 2014 22:26:00 +0000

I sent this reply earlier today. For some reason it doesn't seem to have hit the list so I'm sending it again. Apologies for any duplication.

Scott
-----------
From: Maarten Bosteels [mailto:[email-masked]]
Sent: Wednesday, July 23, 2014 1:49 PM
To: [email-masked]
Cc: Andrew Sullivan; Hollenbeck, Scott; John C Klensin
Subject: Re: [weirds] comments on draft-ietf-weirds-rdap-query-10

Hello,

First of all, apologies for replying to such an old thread.
On Mon, Dec 2, 2013 at 3:40 PM, Hollenbeck, Scott <[email-masked]<mailto:[email-masked]>> wrote:
> -----Original Message-----
> From: weirds [mailto:[email-masked]<mailto:[email-masked]>] On Behalf Of Andrew
> Sullivan
> Sent: Wednesday, November 27, 2013 2:41 PM
> To: [email-masked]<mailto:[email-masked]>
> Subject: [weirds] comments on draft-ietf-weirds-rdap-query-08
>
> Later, "IDN labels SHOULD NOT be represented as a mixture of A-labels
> and U-labels."  I think this probably means "If XXXX contains any IDN
> label, then every IDN label in XXXX SHOULD be either A-labels or
> U-labels, and not a mixture."  Perhaps shorter and still as clear is,
> "IDNs SHOULD NOT be represented as a mixture of A-labels and U-labels;
> that is, any IDN SHOULD use only A-labels or only U-labels."  The
> reason I'm having trouble with this is that "xn--jxalpdlp.com<http://xn--jxalpdlp.com/>"
> contains an A-label and an NR-LDH label, so we can't just say "no
> mixing".  If nobody else finds the existing text possibly misleading,
> I don't feel too strongly about it.
I'll use your text - thanks.

I find the text in draft-ietf-weirds-rdap-query-10<http://tools.ietf.org/html/draft-ietf-weirds-rdap-query-10>  still misleading:  the last part could still be interpreted as if NR-LDH labels are not allowed. The suggested text below is verbose but in my opinion more precise:

OLD:

IDNs SHOULD NOT be represented as a mixture of A-labels and U-labels; that is, any IDN SHOULD use only A-labels or only U-labels.

NEW:

If XXXX contains any IDN label, then either all IDN labels in XXXX SHOULD be represented as A-labels or all IDN labels in XXXX should be represented as U-labels.

Does that make sense ?

[SAH] I'm not sure it does. Section 2.3.2.2 of RFC 5890 says that "These specifications use the term "NR-LDH label" strictly to refer to an all-ASCII label that obeys the LDH label syntax discussed in Section 2.3.1 and that is neither an IDN nor a label form reserved by IDNA (R-LDH label)." So, an NR-LDH label is all-ASCII and it isn't an IDN - and the OLD text above doesn't apply to such labels. I don't see the confusion.

Scott

---

From: Andrew Sullivan <[email-masked]>
Date: Wed, 23 Jul 2014 18:59:16 -0400

Ah, I see the problem.  See inline below.

On Wed, Jul 23, 2014 at 10:26:00PM +0000, Hollenbeck, Scott wrote:
> [SAH] I'm not sure it does. Section 2.3.2.2 of RFC 5890 says that "These specifications use the term "NR-LDH label" strictly to refer to an all-ASCII label that obeys the LDH label syntax discussed…

The confusion is for the case xn--[something].com.  That case is not
strictly allowed under OLD, because "IDN" refers to the whole name and
"com." is not an A-label.  An alternative to NEW would be

    IDNs SHOULD NOT be represented as a mixture of A-labels and
    U-labels; that is, all internationalized labels in an IDN SHOULD be
    either A-labels or U-labels.

I only offer it in case you don't like the "If XXXX contains any IDN
label" locution.  I think they're formally the same.

Best regards,

A 

-- 
Andrew Sullivan
[email-masked]

---

From: "Hollenbeck, Scott" <[email-masked]>
Date: Wed, 23 Jul 2014 23:11:24 +0000

> From: weirds [mailto:[email-masked]] On Behalf Of Andrew
> Sullivan
> Sent: Wednesday, July 23, 2014 6:59 PM
> To: [email-masked]
> > [SAH] I'm not sure it does. Section 2.3.2.2 of RFC 5890 says that
> "These specifications use the term "NR-LDH label" strictly to refer to
> an all-ASCII label that obeys the LDH label syntax discussed in Section
> 2.3.1 and that is neither an IDN nor a label form reserved by IDNA (R-
> LDH label)." So, an NR-LDH label is all-ASCII and it isn't an IDN - and
> the OLD text above doesn't apply to such labels. I don't see the
> confusion.
> >
> 

Thanks, Andrew. Maarten, does this work for you? I'm comfortable with it.

Scott

---

From: Maarten Bosteels <[email-masked]>
Date: Wed, 23 Jul 2014 23:42:18 +0000

>Thanks, Andrew. Maarten, does this work for you? I'm comfortable with it.

Yes, perfect. Thanks.

It was explained (sort of) to me today why mixing U and A labels was a bad
idea. 
But it's only a SHOULD NOT so the next question is:  what should the
server do when it does receive such mixed input ?
Be liberal and do the lookup anyway ?  Or response with a 400 (or 404) ?
I am not saying the behaviour of the server in that case should be
specified in the text, I just wonder what would be the best behaviour
according to the list.

Maarten

---

From: "Hollenbeck, Scott" <[email-masked]>
Date: Wed, 30 Jul 2014 11:56:25 +0000

> From: weirds [mailto:[email-masked]] On Behalf Of Hollenbeck,
> Scott
> Sent: Wednesday, July 23, 2014 7:11 PM
> To: Andrew Sullivan; [email-masked]

Phooey, I missed this in -11. I'll deal with it in -12.

Scott